# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/org/jboss/ejb3/jboss-ejb3-metrics-deployer/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define namedversion %{version}

Name:           jboss-ejb3-metrics-deployer
Version:        1.1.0
Release:        0.4%{?dist}
Epoch:          0
Summary:        JBoss EJB3 Metrics Deployer implementation
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# svn export http://anonsvn.jboss.org/repos/jbossas/projects/ejb3/tags/jboss-ejb3-metrics-deployer-1.1.0/ && tar cjf jboss-ejb3-metrics-deployer-1.1.0.tar.bz2 jboss-ejb3-metrics-deployer-1.1.0
Source0:        jboss-ejb3-metrics-deployer-1.1.0.tar.bz2
Source1:        jboss-ejb3-metrics-deployer-jpp-depmap.xml
Source2:        jboss-ejb3-metrics-deployer-component-info.xml
Patch0:         %{name}-pom_xml.patch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
Requires:       java >= 0:1.5.0
Requires:       jboss-ejb3-build
Requires:       jboss-ejb3-common
Requires:       jboss-ejb3-interceptors
Requires:       jboss-ejb3-proxy-spi
Requires:       jboss-metadata
Requires:       jboss-naming
Requires:       jboss-remoting-aspects
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  ant-junit
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-rar
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:	maven-deploy-plugin
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-jboss-deploy-plugin
BuildRequires:  maven-release-plugin
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  dtdparser
BuildRequires:  glassfish-jaxb
#BuildRequires: glassfish-jaxws
BuildRequires:  gnu-trove
BuildRequires:  hibernate3
BuildRequires:	jboss-aspects-build
BuildRequires:  jboss-deployers
BuildRequires:  jboss-ejb3-core
BuildRequires:  jboss-ejb3-vfs-build
BuildRequires:	jboss-jacc-1.1-api
BuildRequires:  jboss-man
BuildRequires:  jboss-microcontainer2
BuildRequires:  jboss-profiler
BuildRequires:	jboss-security-aspects
BuildRequires:  jboss-serialization
BuildRequires:  jboss-test
BuildRequires:  jboss-transaction-1.0.1-api
BuildRequires:  jboss5-libs
BuildRequires:  jbossweb-servlet-2.5-api
BuildRequires:  quartz
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-jaxp-1.3-apis
BuildRequires:  hsqldb
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss EJB Metrics Deployer implementation.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q 
%patch0 -b .sav0
%{_bindir}/find . -name "*.jar" | %{_bindir}/xargs -t %{__rm} -f

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
%{_bindir}/mvn-jpp -e \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -DaltDeploymentRepository=jboss-releases::default::file://$(pwd)/maven2-brew \
        install deploy:deploy javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -p -m 644 target/jboss-ejb3-metrics-deployer.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -p -m 644 target/%{name}-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-sources.jar
%{jar} -cf $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-javadoc.jar -C target/site/apidocs/ .

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -s ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -p -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.jboss.ejb3 jboss-ejb3-metrics-deployer %{namedversion} JPP %{name}

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
mvn-jpp deploy:deploy-file -e -DpomFile=pom.xml -DrepositoryId=maven2-brew \
    -Durl=file:///%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew \
    -Dfile=$RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-javadoc.jar \
    -Dclassifier=javadoc

install -d -m 755 $RPM_BUILD_ROOT%{repodir}
install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{repodir}/component-info.xml
sed -i "s/@VERSION@/%{version}-brew/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
install -p -m 644 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-ejb3-metrics-deployer.jar
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom $RPM_BUILD_ROOT%{repodirlib}/jboss-ejb3-metrics-deployer.pom
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-javadoc.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-ejb3-metrics-deployer-javadoc.jar
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-sources.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-ejb3-metrics-deployer-sources.jar
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-%{version}.jar
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-%{version}-javadoc.jar
%{_javadir}*/%{name}-javadoc.jar
%{_javadir}*/%{name}-%{version}-sources.jar
%{_javadir}*/%{name}-sources.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Tue Jan 18 2011 Martha Benitez <mbenitez@redhat.com> - 0:1.1.0-0.4
- Rebuild for MEAD

* Thu Nov 25 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.1.0-0.3
- Build with maven 2.2.1
- Change BR maven-release to maven-release-plugin
- Add BR codehaus-stax-api, jboss-aspects-build, jboss-security-aspects, jboss-jacc-1.1-api, maven-deploy-plugin

* Thu Aug 19 2010 David Walluck <dwalluck@redhat.com> 0:1.1.0-0.2
- replace tabs with spaces

* Thu Aug 19 2010 David Walluck <dwalluck@redhat.com> 0:1.1.0-0.1
- 1.1.0
- BuildRequires: jboss-ejb3-vfs-build

* Thu May 06 2010 Martha Benitez <mbenitez@redhat.com> 0:1.0.2-1.1.1
- rebuilt

* Mon Apr 12 2010 Yong Yang <yyang@redhat.com> 0:1.0.2-1.1
- Change BR jbossweb2-servlet-2.5-api to BR jbossweb-servlet-2.5-api
- BR hsqldb
- Fix depmaps for dtdparser and ejb3-persistence
- Rebuild for generating signed jar

* Fri Dec 04 2009 Martha Benitez <mbenitez@redhat.com> 0:1.0.2-1
- Upgrade to 1.0.2
- Add javadoc and sources jar files to repolib

* Wed Oct 14 2009 David Walluck <dwalluck@redhat.com> 0:1.0.1-1.2
- update pom_xml patch with version
- update License
- fix javadoc permissions
- fix repolib file ownership
- fix component-info.xml in repolib
- fix repolib location
- fix repolib permissions

* Tue Sep 29 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.0.1-1.1
- Fix component-info.xml
- Comment BR glassfish-jaxws

* Thu Sep 10 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.0.1
- First release
